package sun.rmi.transport.proxy;

import java.io.IOException;
import java.io.DataOutputStream;
import java.io.OutputStream;
import java.io.ByteArrayOutputStream;

class HttpOutputStream extends ByteArrayOutputStream
{
    protected OutputStream out;
    boolean responseSent;
    private static byte[] emptyData;
    
    public HttpOutputStream(OutputStream out) {
        this.responseSent = false;
        this.out = out;
    }
    
    @Override
    public synchronized void close() throws IOException {
        if (!this.responseSent) {
            if (this.size() == 0) {
                this.write(HttpOutputStream.emptyData);
            }
            DataOutputStream out = new DataOutputStream(this.out);
            out.writeBytes("Content-type: application/octet-stream\r\n");
            out.writeBytes("Content-length: " + this.size() + "\r\n");
            out.writeBytes("\r\n");
            this.writeTo(out);
            out.flush();
            this.reset();
            this.responseSent = true;
        }
    }
    
    static {
        HttpOutputStream.emptyData = new byte[] { 0 };
    }
}
